## forge 0.1.0

=== DESCRIPTION ===
Package: forge
Type: Package
Title: Casting Values into Shape
Version: 0.1.0
Authors@R: c(
  person("Kevin", "Kuo", role = c("aut", "cre"), email = "kevin.kuo@rstudio.com",
  comment = c(ORCID = "0000-0001-7803-7901"))
  )
Description: Helper functions with a consistent interface to coerce and verify
    the types and shapes of values for input checking.
License: Apache License (>= 2.0)
Encoding: UTF-8
LazyData: true
Depends: R (>= 3.1.2)
Imports: rlang
RoxygenNote: 6.1.0
Suggests: testthat, covr
NeedsCompilation: no
Packaged: 2018-08-27 05:24:47 UTC; kevinykuo
Author: Kevin Kuo [aut, cre] (<https://orcid.org/0000-0001-7803-7901>)
Maintainer: Kevin Kuo <kevin.kuo@rstudio.com>
Repository: CRAN
Date/Publication: 2018-08-31 19:00:06 UTC

## forge 0.2.0

=== DESCRIPTION ===
Package: forge
Type: Package
Title: Casting Values into Shape
Version: 0.2.0
Authors@R: c(
  person("Kevin", "Kuo", role = c("aut", "cre"), email = "kevin.kuo@rstudio.com",
  comment = c(ORCID = "0000-0001-7803-7901"))
  )
Description: Helper functions with a consistent interface to coerce and verify
    the types and shapes of values for input checking.
License: Apache License (>= 2.0)
Encoding: UTF-8
LazyData: true
Depends: R (>= 3.1.2)
Imports: rlang (>= 0.3.1), magrittr
RoxygenNote: 6.1.0
Suggests: testthat, covr
NeedsCompilation: no
Packaged: 2019-02-26 15:41:55 UTC; kevinykuo
Author: Kevin Kuo [aut, cre] (<https://orcid.org/0000-0001-7803-7901>)
Maintainer: Kevin Kuo <kevin.kuo@rstudio.com>
Repository: CRAN
Date/Publication: 2019-02-26 16:00:03 UTC

## forge 0.9.2

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.0)
PROJECT(FORGE)

SET_PROPERTY(GLOBAL PROPERTY USE_FOLDERS ON)
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules")
INCLUDE(FGInstallDirs)

SET(USE_WINDOW_TOOLKIT "glfw3" CACHE STRING "Choose Window toolkit")
SET_PROPERTY(CACHE USE_WINDOW_TOOLKIT PROPERTY STRINGS "glfw3" "sdl2")

OPTION(BUILD_DOCUMENTATION "Build Documentation" OFF)
OPTION(BUILD_EXAMPLES "Build Examples" ON)

OPTION(USE_LOCAL_GLM "Download and use local GLM" OFF)
OPTION(USE_LOCAL_FREETYPE "Download and use local freetype" OFF)
MARK_AS_ADVANCED(USE_LOCAL_GLM)
MARK_AS_ADVANCED(USE_LOCAL_FREETYPE)

# Set a default build type if none was specified
IF(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
    # Set the possible values of build type for cmake-gui
    SET_PROPERTY(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
      "MinSizeRel" "RelWithDebInfo")
ENDIF()

IF(UNIX)
    ADD_DEFINITIONS(-Wall -std=c++11 -fvisibility=hidden)
ENDIF()

# OS Definitions
IF(UNIX)
    IF(APPLE)
        ADD_DEFINITIONS(-DOS_MAC)
        SET(CMAKE_MACOSX_RPATH ON)
        SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
        SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
        SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}")
        SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

        LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}" isSystemDir)
        IF("${isSystemDir}" STREQUAL "-1")
            SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}")
        ENDIF("${isSystemDir}" STREQUAL "-1")
    ELSE(APPLE)
        ADD_DEFINITIONS(-DOS_LNX)
    ENDIF(APPLE)
ELSE(UNIX)
    ADD_DEFINITIONS(-DOS_WIN -DNOMINMAX)
ENDIF(UNIX)

INCLUDE(Version)

FIND_PACKAGE(FreeImage REQUIRED)
FIND_PACKAGE(OpenGL REQUIRED)

INCLUDE_DIRECTORIES(
    "${PROJECT_SOURCE_DIR}/include"
    ${OPENGL_INCLUDE_DIR}
    ${FREEIMAGE_INCLUDE_PATH}
    )

SET(X11_LIBS "")
IF(APPLE)
    FIND_PACKAGE(X11 REQUIRED)
    INCLUDE_DIRECTORIES(${X11_INCLUDE_DIR})
    SET(X11_LIBS ${X11_LIBRARIES})
ENDIF(APPLE)

ADD_EXECUTABLE(glsl2cpp "${PROJECT_SOURCE_DIR}/CMakeModules/glsl2cpp.cpp")

ADD_SUBDIRECTORY(src/backend/opengl)

IF(BUILD_EXAMPLES)
    ADD_SUBDIRECTORY(examples)
ENDIF()

# Generate documentation
IF(BUILD_DOCUMENTATION)
    ADD_SUBDIRECTORY(docs)
ENDIF(BUILD_DOCUMENTATION)

#--------------------------------------------------------------------
# Create generated files
#--------------------------------------------------------------------
INCLUDE(CMakePackageConfigHelpers)

configure_package_config_file("${PROJECT_SOURCE_DIR}/CMakeModules/ForgeConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/ForgeConfig.cmake"
                              INSTALL_DESTINATION ${FG_INSTALL_CMAKE_DIR}
                              PATH_VARS CMAKE_INSTALL_PREFIX
                              NO_CHECK_REQUIRED_COMPONENTS_MACRO)

write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/ForgeConfigVersion.cmake"
                                 VERSION ${FG_VERSION}
                                 COMPATIBILITY SameMajorVersion)

#--------------------------------------------------------------------
# Install files other than the library, examples and docs
# The library is installed by src/CMakeLists.txt
#--------------------------------------------------------------------
INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/include/" DESTINATION "${FG_INSTALL_INC_DIR}"
    FILES_MATCHING
    PATTERN "*.h"
    PATTERN "*.hpp"
    PATTERN ".gitignore" EXCLUDE
)

INSTALL(FILES "${CMAKE_CURRENT_BINARY_DIR}/ForgeConfig.cmake"
              "${CMAKE_CURRENT_BINARY_DIR}/ForgeConfigVersion.cmake"
              DESTINATION ${FG_INSTALL_CMAKE_DIR})

# We are only installing the source files for examples.
# So this should not depend on the value of BUILD_EXAMPLES
# These examples will be installed without building the executables for the examples
INSTALL(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/examples/"
        DESTINATION "${FG_INSTALL_EXAMPLE_DIR}"
        COMPONENT examples)

INSTALL(FILES
        "${PROJECT_SOURCE_DIR}/CMakeModules/FindOpenCL.cmake"
        DESTINATION "${FG_INSTALL_EXAMPLE_DIR}/CMakeModules/"
        COMPONENT examples)

=== docs/CMakeLists.txt ===
FIND_PACKAGE(Doxygen REQUIRED)

# Documentation
IF(NOT DEFINED FG_INSTALL_DOC_DIR)
    SET(FG_INSTALL_DOC_DIR "${FG_INSTALL_DATA_DIR}/doc" CACHE PATH "Installation path for documentation")
ENDIF()

SET(FG_DOCS_CONFIG "${CMAKE_CURRENT_SOURCE_DIR}/doxygen.mk")
SET(FG_DOCS_CONFIG_OUT "${CMAKE_CURRENT_BINARY_DIR}/doxygen.mk.out")

SET(FG_DOCS_LAYOUT "${CMAKE_CURRENT_SOURCE_DIR}/layout.xml")
SET(FG_DOCS_LAYOUT_OUT "${CMAKE_CURRENT_BINARY_DIR}/layout.xml.out")

SET(DOCS_DIR     "${CMAKE_CURRENT_SOURCE_DIR}")
SET(ASSETS_DIR   "${CMAKE_CURRENT_SOURCE_DIR}/images")
SET(INCLUDE_DIR  "${PROJECT_SOURCE_DIR}/include")
SET(EXAMPLES_DIR "${PROJECT_SOURCE_DIR}/examples")
#Re-enable test snippets directory setting when doc examples are added
#SET(SNIPPETS_DIR "${PROJECT_SOURCE_DIR}/test")
CONFIGURE_FILE(${FG_DOCS_CONFIG} ${FG_DOCS_CONFIG_OUT})
CONFIGURE_FILE(${FG_DOCS_LAYOUT} ${FG_DOCS_LAYOUT_OUT})

###########################################################
## This generates a list of the examples cpp files and
## creates a dox file under docs/details/examples.dox
## This is used to generate documentation for examples
###########################################################
FILE(GLOB EXAMPLES_CPP
    "${EXAMPLES_DIR}/cpu/*.cpp"
    "${EXAMPLES_DIR}/cuda/*.cu"
    "${EXAMPLES_DIR}/opencl/*.cpp"
    "${EXAMPLES_DIR}/opencl/*.h"
    )

# Sort alphabetically
# Note: example directories will be major sort order
LIST(SORT EXAMPLES_CPP)

# Get filenames and write to a string
FOREACH(SRC ${EXAMPLES_CPP})
    GET_FILENAME_COMPONENT(DIR_PATH ${SRC} DIRECTORY)
    GET_FILENAME_COMPONENT(DIR_NAME ${DIR_PATH} NAME)
    GET_FILENAME_COMPONENT(SRC_NAME ${SRC} NAME)
    SET(EXAMPLES_LIST "${EXAMPLES_LIST}\\example ${DIR_NAME}/${SRC_NAME}\n")
ENDFOREACH(SRC ${EXAMPLES_CPP})

# Write string containing file names to examples.dox
CONFIGURE_FILE(
    ${PROJECT_SOURCE_DIR}/CMakeModules/examples.dox.in
    ${DOCS_DIR}/details/examples.dox
)
###########################################################

ADD_CUSTOM_TARGET(docs
    ALL
    COMMAND ${DOXYGEN_EXECUTABLE} ${FG_DOCS_CONFIG_OUT}
    COMMAND cmake -E copy_directory ${ASSETS_DIR} ${CMAKE_CURRENT_BINARY_DIR}/html
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating Documentation"
    VERBATIM)

# Install Doxygen documentation
INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
    DESTINATION ${FG_INSTALL_DOC_DIR}
    COMPONENT documentation
    PATTERN "*"
    PATTERN ".git" EXCLUDE
    PATTERN "CMakeFiles" EXCLUDE
    PATTERN "man" EXCLUDE
    )

=== examples/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
PROJECT(Forge-Examples)

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules")

OPTION(BUILD_EXAMPLES_CUDA "Turn off/on building cuda examples" ON)
OPTION(BUILD_EXAMPLES_OPENCL "Turn off/on building opencl examples" ON)
OPTION(USE_SYSTEM_CL2HPP "Use cl2.hpp header installed on the system" OFF)

IF(NOT USE_SYSTEM_CL2HPP)
    INCLUDE(build_cl2hpp)
ENDIF()

MACRO(BUILD_EXAMPLE EX_NAME EX_SRC COMPUTE_NAME FG_LIBS COMPUTE_LIBS)
    IF(${COMPUTE_NAME} STREQUAL "cuda")
        CUDA_ADD_EXECUTABLE(example_${EX_NAME}_${COMPUTE_NAME} ${EX_SRC})
    ELSE()
        ADD_EXECUTABLE(example_${EX_NAME}_${COMPUTE_NAME} ${EX_SRC})
    ENDIF()
    TARGET_LINK_LIBRARIES(example_${EX_NAME}_${COMPUTE_NAME} ${COMPUTE_LIBS} ${FG_LIBS})
    SET_TARGET_PROPERTIES(example_${EX_NAME}_${COMPUTE_NAME}
        PROPERTIES
        OUTPUT_NAME ${EX_NAME}_${COMPUTE_NAME}
        RUNTIME_OUTPUT_DIRECTORY ${DIR_NAME}
        FOLDER "Examples/${COMPUTE_NAME}")
    IF(${COMPUTE_NAME} STREQUAL "opencl")
        IF(NOT USE_SYSTEM_CL2HPP)
            ADD_DEPENDENCIES(example_${EX_NAME}_${COMPUTE_NAME} cl2hpp)
        ENDIF()
    ENDIF()
ENDMACRO()

IF(TARGET forge)

    # Building with Forge Source
    SET(FORGE_FOUND False)

ELSE(TARGET forge)

    SET_PROPERTY(GLOBAL PROPERTY USE_FOLDERS ON)
    FIND_PACKAGE(FreeImage REQUIRED)
    FIND_PACKAGE(OpenGL REQUIRED)
    FIND_PACKAGE(Forge REQUIRED)

    SET(X11_LIBS "")

    INCLUDE_DIRECTORIES(
        ${FORGE_INCLUDE_DIRS}
        ${FREEIMAGE_INCLUDE_PATH}
        )

    # OS Definitions
    IF(UNIX)
        ADD_DEFINITIONS(-Wall -std=c++11 -fvisibility=hidden)

        # GCC 5.3 and above give errors for mempcy from <string.h>
        # This is a (temporary) fix for that
        IF("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER "5.3.0")
            ADD_DEFINITIONS(-D_FORCE_INLINES)
        ENDIF()

        # MacOS specific environment settings
        IF(APPLE)
            ADD_DEFINITIONS(-DOS_MAC)
            SET(CMAKE_MACOSX_RPATH ON)
            SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
            SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
            SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}")
            SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

            LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}" isSystemDir)
            IF("${isSystemDir}" STREQUAL "-1")
                SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}")
            ENDIF("${isSystemDir}" STREQUAL "-1")

            FIND_PACKAGE(X11 REQUIRED)
            INCLUDE_DIRECTORIES(${X11_INCLUDE_DIR})

        ELSE(APPLE)
            ADD_DEFINITIONS(-DOS_LNX)
        ENDIF(APPLE)
    ELSE(UNIX)
        ADD_DEFINITIONS(-DOS_WIN -DNOMINMAX)
    ENDIF(UNIX)
ENDIF(TARGET forge)

IF(UNIX)
    SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations -Wno-unused-function")
ENDIF()

FILE(GLOB CPU_EXAMPLE_SRC_FILES "cpu/*.cpp")
LIST(SORT CPU_EXAMPLE_SRC_FILES)
FOREACH(FILE ${CPU_EXAMPLE_SRC_FILES})
    GET_FILENAME_COMPONENT(EXAMPLE ${FILE} NAME_WE)
    GET_FILENAME_COMPONENT(FULL_DIR_NAME ${FILE} PATH)
    GET_FILENAME_COMPONENT(DIR_NAME ${FULL_DIR_NAME} NAME)

    IF(TARGET forge)
        BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} forge
            "${FREEIMAGE_LIBRARY};${OPENGL_gl_LIBRARY}")
    ELSE(TARGET forge)
        BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} ${FORGE_LIBRARIES}
            "${FREEIMAGE_LIBRARY};${OPENGL_gl_LIBRARY};${X11_LIBS};")
    ENDIF()
ENDFOREACH()

IF (BUILD_EXAMPLES_CUDA)
    FIND_PACKAGE(CUDA QUIET)
    IF(CUDA_FOUND)

        IF(UNIX)
            # GCC 5.3 and above give errors for mempcy from <string.h>
            # This is a (temporary) fix for that
            IF("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER "5.3.0")
                ADD_DEFINITIONS(-D_FORCE_INLINES)
            ENDIF()
            # GCC 6.0 and above default to g++14, enabling c++11 features by default
            # Enabling c++11 with nvcc 7.5 + gcc 6.x doesn't seem to work
            # Only solution for now is to force use c++03 for gcc 6.x
            IF("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER "6.0.0")
                SET(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -Xcompiler -std=c++98")
            ENDIF()
        ENDIF(UNIX)

        INCLUDE_DIRECTORIES(${CUDA_INCLUDE_DIRS})

        FILE(GLOB CUDA_EXAMPLE_SRC_FILES "cuda/*.cu")
        LIST(SORT CUDA_EXAMPLE_SRC_FILES)
        FOREACH(FILE ${CUDA_EXAMPLE_SRC_FILES})
            GET_FILENAME_COMPONENT(EXAMPLE ${FILE} NAME_WE)
            GET_FILENAME_COMPONENT(FULL_DIR_NAME ${FILE} PATH)
            GET_FILENAME_COMPONENT(DIR_NAME ${FULL_DIR_NAME} NAME)

            IF(TARGET forge)
                BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} forge
                    "${FREEIMAGE_LIBRARY};${CUDA_LIBRARIES}")
            ELSE(TARGET forge)
                BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} ${FORGE_LIBRARIES}
                    "${FREEIMAGE_LIBRARY};${OPENGL_gl_LIBRARY};${X11_LIBS};${CUDA_LIBRARIES}")
            ENDIF()
        ENDFOREACH()
    ELSE()
        MESSAGE(STATUS "CUDA Toolkit not found, not building CUDA examples.")
    ENDIF()
ENDIF()

IF (BUILD_EXAMPLES_OPENCL)
    FIND_PACKAGE(OpenCL QUIET)
    IF(OpenCL_FOUND)
        FILE(GLOB OpenCL_EXAMPLE_SRC_FILES "opencl/*.cpp")
        LIST(SORT OpenCL_EXAMPLE_SRC_FILES)
        INCLUDE_DIRECTORIES(
            "${CMAKE_CURRENT_SOURCE_DIR}/opencl"
            ${OpenCL_INCLUDE_DIRS}
            ${CL2HPP_INCLUDE_DIRECTORY}
            )
        FOREACH(FILE ${OpenCL_EXAMPLE_SRC_FILES})
            GET_FILENAME_COMPONENT(EXAMPLE ${FILE} NAME_WE)
            GET_FILENAME_COMPONENT(FULL_DIR_NAME ${FILE} PATH)
            GET_FILENAME_COMPONENT(DIR_NAME ${FULL_DIR_NAME} NAME)

            IF(TARGET forge)
                BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} forge
                    "${FREEIMAGE_LIBRARY};${OPENGL_gl_LIBRARY};${OpenCL_LIBRARIES}")
            ELSE(TARGET forge)
                BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} ${FORGE_LIBRARIES}
                    "${FREEIMAGE_LIBRARY};${OPENGL_gl_LIBRARY};${X11_LIBS};${OpenCL_LIBRARIES}")
            ENDIF()
        ENDFOREACH()
    ELSE()
        MESSAGE(STATUS "OpenCL Libraries not found, not building OpenCL examples.")
    ENDIF()
ENDIF()

MARK_AS_ADVANCED(BUILD_EXAMPLES_CUDA BUILD_EXAMPLES_OPENCL)

=== src/backend/opengl/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.0)
# Prior to GLM 0.9.7.0, the package is found by the FindGLM.cmake module.
# This was removed with GLM 0.9.7.0, instead a glm-config.cmake configuration
# file is provided. Therefore, both FIND_PACKAGE calls are necessary.
FIND_PACKAGE(GLM QUIET)
FIND_PACKAGE(glm QUIET)

OPTION(USE_SYSTEM_GLBINDING "Use system glbinding" OFF)
IF(USE_SYSTEM_GLBINDING)
    # Point glbinding_DIR (case sensitive) to the location of glbinding-config.cmake
    # This file is generally at CMAKE_INSTALL_PREFIX/glbinding-config.cmake of
    # the glbinding project
    FIND_PACKAGE(glbinding REQUIRED)
ELSE(USE_SYSTEM_GLBINDING)
    INCLUDE(build_glbinding)
ENDIF(USE_SYSTEM_GLBINDING)

INCLUDE(GLSLtoH)

IF((NOT glm_FOUND AND NOT GLM_FOUND) OR (${USE_LOCAL_GLM}))
  SET(USE_LOCAL_GLM ON)
  MESSAGE(STATUS "Downloading GLM headers.")
  INCLUDE(build_glm)
ELSE()
  MESSAGE(STATUS "Using System GLM")
ENDIF()

FIND_PACKAGE(Freetype QUIET)

IF(NOT FREETYPE_FOUND OR ${USE_LOCAL_FREETYPE})
  SET(USE_LOCAL_FREETYPE ON)
  MESSAGE(STATUS "Downloading and building Freetype libraries.")
  INCLUDE(build_freetype)
ELSE()
  MESSAGE(STATUS "Using System FreeType2")
ENDIF()

IF(UNIX)
    FIND_PACKAGE(FontConfig REQUIRED)
ENDIF(UNIX)

IF(${USE_WINDOW_TOOLKIT} STREQUAL "glfw3")
    FIND_PACKAGE(GLFW REQUIRED)
    IF(GLFW_FOUND)
        SET(WTK_INCLUDE_DIRS ${GLFW_INCLUDE_DIR})
        SET(WTK_LIBRARIES ${GLFW_LIBRARY})
        ADD_DEFINITIONS(-DUSE_GLFW)
    ELSE(GLFW_FOUND)
        MESSAGE(FATAL_ERROR "GLFW not found")
    ENDIF(GLFW_FOUND)
ENDIF()

IF(${USE_WINDOW_TOOLKIT} STREQUAL "sdl2")
    FIND_PACKAGE(SDL2 REQUIRED)
    IF(SDL2_FOUND)
        SET(WTK_INCLUDE_DIRS ${SDL2_INCLUDE_DIR})
        SET(WTK_LIBRARIES ${SDL2_LIBRARY})
        ADD_DEFINITIONS(-DUSE_SDL)
    ELSE(SDL2_FOUND)
        MESSAGE(FATAL_ERROR "SDL2 not found")
    ENDIF(SDL2_FOUND)
ENDIF()


IF(WIN32)
    ADD_DEFINITIONS(-DFGDLL)
ENDIF(WIN32)

# OS Definitions
IF(UNIX)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
ELSE(UNIX) #Windows
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
ENDIF(UNIX)

# DON'T REMOVE CURRENT BINARY DIRECTORY FROM
# INCLUDE_DIRECTORIES, IT IS USED TO FIND
# AUTO-GENERATED GLSL HEADERS
INCLUDE_DIRECTORIES(
    ${CMAKE_INCLUDE_PATH}
    ${FREETYPE_INCLUDE_DIRS}
    ${GLM_INCLUDE_DIRS}
    ${WTK_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    "${PROJECT_SOURCE_DIR}/src/api/c"
    "${PROJECT_SOURCE_DIR}/src/api/cpp"
    "${PROJECT_SOURCE_DIR}/src/backend"
    )

IF(UNIX)
    INCLUDE_DIRECTORIES("${FONTCONFIG_INCLUDE_DIR}")
ENDIF(UNIX)

FILE(GLOB api_headers
    "${PROJECT_SOURCE_DIR}/include/*.h"
    "${PROJECT_SOURCE_DIR}/include/fg/*.h"
    )

FILE(GLOB c_api_headers
    "${PROJECT_SOURCE_DIR}/src/api/c/*.hpp"
    )
FILE(GLOB c_api_sources
    "${PROJECT_SOURCE_DIR}/src/api/c/*.cpp"
    )
FILE(GLOB cpp_api_headers
    "${PROJECT_SOURCE_DIR}/src/api/cpp/*.hpp"
    )
FILE(GLOB cpp_api_sources
    "${PROJECT_SOURCE_DIR}/src/api/cpp/*.cpp"
    )

FILE(GLOB bknd_headers
    "${PROJECT_SOURCE_DIR}/src/backend/*.hpp"
    )

FILE(GLOB bknd_sources
    "${PROJECT_SOURCE_DIR}/src/backend/*.cpp"
    )

FILE(GLOB gl_headers
    "*.hpp"
    "*.h"
    )

FILE(GLOB gl_sources
    "*.c"
    "*.cpp"
    )

SET(glsl_shader_headers
    "shader_headers")
FILE(GLOB glsl_shaders
    "shaders/*.glsl")

LIST(SORT c_api_headers)
LIST(SORT c_api_sources)
LIST(SORT cpp_api_headers)
LIST(SORT cpp_api_sources)
LIST(SORT bknd_headers)
LIST(SORT bknd_sources)
LIST(SORT gl_headers)
LIST(SORT gl_sources)
LIST(SORT glsl_shaders)

SOURCE_GROUP(inc FILES ${api_headers})

SOURCE_GROUP("src\\api\\c\\headers" FILES ${c_api_headers})
SOURCE_GROUP("src\\api\\c\\sources" FILES ${c_api_sources})

SOURCE_GROUP("src\\api\\cpp\\headers" FILES ${cpp_api_headers})
SOURCE_GROUP("src\\api\\cpp\\sources" FILES ${cpp_api_sources})

SOURCE_GROUP("src\\backend" FILES ${bknd_headers})
SOURCE_GROUP("src\\backend" FILES ${bknd_sources})

SOURCE_GROUP("src\\backend\\opengl\\headers" FILES ${gl_headers})
SOURCE_GROUP("src\\backend\\opengl\\sources" FILES ${gl_sources})

IF(${USE_WINDOW_TOOLKIT} STREQUAL "glfw3")
    FILE(GLOB wtk_headers
        "glfw/*.hpp")
    FILE(GLOB wtk_sources
        "glfw/*.cpp")
    SOURCE_GROUP("src\\backend\\opengl\\glfw\\headers" FILES ${wtk_headers})
    SOURCE_GROUP("src\\backend\\opengl\\glfw\\sources" FILES ${wtk_sources})
ELSEIF(${USE_WINDOW_TOOLKIT} STREQUAL "sdl2")
    FILE(GLOB wtk_headers
        "sdl/*.hpp")
    FILE(GLOB wtk_sources
        "sdl/*.cpp")
    SOURCE_GROUP("src\\backend\\opengl\\sdl\\headers" FILES ${wtk_headers})
    SOURCE_GROUP("src\\backend\\opengl\\sdl\\sources" FILES ${wtk_sources})
ENDIF()

SOURCE_GROUP("src\\backend\\opengl\\glsl" FILES ${glsl_shaders})

GLSL_TO_H(
    SOURCES ${glsl_shaders}
    VARNAME  shader_files
    EXTENSION "hpp"
    OUTPUT_DIR ${glsl_shader_headers}
    TARGETS glsl_shader_targets
    NAMESPACE "glsl"
    EOD "0"
    )

ADD_LIBRARY(forge SHARED
    ${api_headers}
    ${c_api_headers}
    ${c_api_sources}
    ${cpp_api_headers}
    ${cpp_api_sources}
    ${bknd_headers}
    ${bknd_sources}
    ${gl_headers}
    ${gl_sources}
    ${wtk_headers}
    ${wtk_sources}
    )

TARGET_LINK_LIBRARIES(forge
    PRIVATE ${FONTCONFIG_LIBRARY}
    PRIVATE ${FREETYPE_LIBRARIES}
    PRIVATE ${WTK_LIBRARIES}
    PRIVATE ${OPENGL_gl_LIBRARY}
    PRIVATE ${FREEIMAGE_LIBRARY}
    PRIVATE ${X11_LIBS}
    )

ADD_DEPENDENCIES(forge ${glsl_shader_targets})
IF(USE_SYSTEM_GLBINDING)
    TARGET_LINK_LIBRARIES(forge PRIVATE glbinding::glbinding)
ELSE(USE_SYSTEM_GLBINDING)
    INCLUDE_DIRECTORIES(${GLBINDING_INCLUDE_DIRS})
    TARGET_LINK_LIBRARIES(forge PRIVATE ${GLBINDING_LIBRARIES})
    ADD_DEPENDENCIES(forge glbinding)
ENDIF(USE_SYSTEM_GLBINDING)

SET_TARGET_PROPERTIES(forge PROPERTIES
                      VERSION ${FG_VERSION}
                      SOVERSION 0)

INSTALL(TARGETS forge
        EXPORT FORGE
        DESTINATION "${FG_INSTALL_LIB_DIR}"
        COMPONENT libraries)

EXPORT(TARGETS forge FILE ForgeTargets.cmake)

INSTALL(EXPORT FORGE DESTINATION "${FG_INSTALL_CMAKE_DIR}"
        COMPONENT cmake
        FILE ForgeTargets.cmake
       )

=== debian/changelog ===
forge (0.9.2-2) unstable; urgency=medium

  * Cherry-pick upstream patch facilitating builds with system libraries.
    New patch 0003-Consistent-definition-of-USE_SYSTEM-flags-for-glbind.patch
  * Force use of system dependencies via the USE_SYSTEM flags.
    Reason: fixes FTBFS during reproducible builds
  * Add missing build dependency on OpenGL.
    Reason: fixes FTBFS on sparc64
  * Add support for the nodoc build profile.
  * Add patch fixing spelling errors reported by Lintian.
    New patch 0004-Fix-spelling-errors.patch

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 04 Jan 2017 20:42:05 +0000

forge (0.9.2-1) unstable; urgency=medium

  * Switch to git-dpm.
  * New upstream release.
  * Drop patch Fix-build-of-examples-with-the-system-cl2hpp.patch, applied
    upstream.
  * New patch No-version-queries-with-Git.patch, avoid spurious "git not
    found" entries in the build log when the documentation is generated.
  * Drop gbp configuration in favor of git-dpm
  * Upgrade packaging to debhelper 10
  * Use architecture.mk to query DEB_HOST_MULTIARCH
  * Cosmetic fixup of rules file

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 21 Dec 2016 19:29:03 +0000

forge (0.9.0-2) unstable; urgency=medium

  * Update patch queue.
    - Refresh Use-system-MathJax.patch.
    - New patch Fix-build-of-examples-with-the-system-cl2hpp.patch.
  * Add packaging testsuite.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 06 Dec 2016 19:37:43 +0000

forge (0.9.0-1) unstable; urgency=low

  * Initial release. (Closes: #834723)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 14 Sep 2016 00:25:40 +0100

=== debian/control ===
Source: forge
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Priority: optional
Build-Depends: cmake (>= 3.0),
               debhelper (>= 10),
               dpkg-dev (>= 1.17.14),
               libfontconfig1-dev,
               libfreeimage-dev,
               libfreetype6-dev,
               libgl1-mesa-dev | libgl-dev,
               libglbinding-dev,
               libglfw3-dev,
               libglm-dev
Build-Depends-Indep: doxygen <!nodoc>
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/forge.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/forge.git
Homepage: https://github.com/arrayfire/forge

Package: libforge0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: high-performance OpenGL visualization
 A prototype of the OpenGL interop library that can be used with ArrayFire. The
 goal of Forge is to provide high performance OpenGL visualizations for C/C++
 applications that use CUDA/OpenCL.
 .
 This package provides the shared libraries.

Package: libforge-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libforge0 (= ${binary:Version})
Suggests: forge-doc <!nodoc>
Description: development files for forge
 A prototype of the OpenGL interop library that can be used with ArrayFire. The
 goal of Forge is to provide high performance OpenGL visualizations for C/C++
 applications that use CUDA/OpenCL.
 .
 This package provides the development files.

Package: forge-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-mathjax
Description: documentation for forge
 A prototype of the OpenGL interop library that can be used with ArrayFire. The
 goal of Forge is to provide high performance OpenGL visualizations for C/C++
 applications that use CUDA/OpenCL.
 .
 This package provides the documentation.
Build-Profiles: <!nodoc>

=== debian/tests/control ===
Test-Command: cp -a CMakeModules examples/* $AUTOPKGTEST_TMP
 ; cd $AUTOPKGTEST_TMP
 ; mkdir build
 ; cd build
 ; cmake -DBUILD_EXAMPLES_CUDA=OFF -DBUILD_EXAMPLES_OPENCL=ON -DUSE_SYSTEM_CL2HPP=ON ..
 ; cmake --build .
Depends: @, cmake, g++ | c++-compiler, libfreeimage-dev, libgl1-mesa-dev | libgl-dev,
 ocl-icd-opencl-dev | opencl-dev, opencl-clhpp-headers

## forge 1.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,20 +1,29 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 3.0)
+
+OPTION(USE_HUNTER "Use Hunter cmake package handler" OFF)
+
+if(USE_HUNTER)
+    include(${CMAKE_CURRENT_LIST_DIR}/CMakeModules/HunterGate.cmake)
+    
+    HunterGate(
+        URL "https://github.com/ruslo/hunter/archive/v0.18.43.tar.gz"
+        SHA1 "d2c8c42cd07f7cefe18fd9a9b9c13114b1a15a27"
+#        LOCAL
+    )
+endif()
+
 PROJECT(FORGE)
 
 SET_PROPERTY(GLOBAL PROPERTY USE_FOLDERS ON)
 SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules")
 INCLUDE(FGInstallDirs)
+INCLUDE(Version)
 
-SET(USE_WINDOW_TOOLKIT "glfw3" CACHE STRING "Choose Window toolkit")
-SET_PROPERTY(CACHE USE_WINDOW_TOOLKIT PROPERTY STRINGS "glfw3" "sdl2")
 
+############################## BEGIN - CMAKE OPTIONS ##########################
 OPTION(BUILD_DOCUMENTATION "Build Documentation" OFF)
 OPTION(BUILD_EXAMPLES "Build Examples" ON)
-
-OPTION(USE_LOCAL_GLM "Download and use local GLM" OFF)
-OPTION(USE_LOCAL_FREETYPE "Download and use local freetype" OFF)
-MARK_AS_ADVANCED(USE_LOCAL_GLM)
-MARK_AS_ADVANCED(USE_LOCAL_FREETYPE)
+OPTION(USE_FREEIMAGE "Use freeimage to allow saving of charts" ON)
 
 # Set a default build type if none was specified
 IF(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
@@ -23,12 +32,14 @@
     SET_PROPERTY(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
       "MinSizeRel" "RelWithDebInfo")
 ENDIF()
+############################## END - CMAKE OPTIONS ##########################
 
+
+############################## BEGIN - OS Definitions #########################
 IF(UNIX)
     ADD_DEFINITIONS(-Wall -std=c++11 -fvisibility=hidden)
 ENDIF()
 
-# OS Definitions
 IF(UNIX)
     IF(APPLE)
         ADD_DEFINITIONS(-DOS_MAC)
@@ -45,21 +56,19 @@
     ELSE(APPLE)
         ADD_DEFINITIONS(-DOS_LNX)
     ENDIF(APPLE)
+    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
 ELSE(UNIX)
     ADD_DEFINITIONS(-DOS_WIN -DNOMINMAX)
+    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
 ENDIF(UNIX)
+############################## END - OS Definitions ###########################
 
-INCLUDE(Version)
 
-FIND_PACKAGE(FreeImage REQUIRED)
-FIND_PACKAGE(OpenGL REQUIRED)
+INCLUDE_DIRECTORIES("${PROJECT_SOURCE_DIR}/include")
 
-INCLUDE_DIRECTORIES(
-    "${PROJECT_SOURCE_DIR}/include"
-    ${OPENGL_INCLUDE_DIR}
-    ${FREEIMAGE_INCLUDE_PATH}
-    )
-
+## X11 libraries need to be explicitly linked on MacOS
+## This is required by both examples and the library itself
+## Hence, it is placed here.
 SET(X11_LIBS "")
 IF(APPLE)
     FIND_PACKAGE(X11 REQUIRED)
@@ -67,9 +76,7 @@
     SET(X11_LIBS ${X11_LIBRARIES})
 ENDIF(APPLE)
 
-ADD_EXECUTABLE(glsl2cpp "${PROJECT_SOURCE_DIR}/CMakeModules/glsl2cpp.cpp")
-
-ADD_SUBDIRECTORY(src/backend/opengl)
+ADD_SUBDIRECTORY(src/backend)
 
 IF(BUILD_EXAMPLES)
     ADD_SUBDIRECTORY(examples)
@@ -97,7 +104,7 @@
 
 #--------------------------------------------------------------------
 # Install files other than the library, examples and docs
-# The library is installed by src/CMakeLists.txt
+# The library is installed by src/backend/*/CMakeLists.txt
 #--------------------------------------------------------------------
 INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/include/" DESTINATION "${FG_INSTALL_INC_DIR}"
     FILES_MATCHING

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -38,16 +38,12 @@
 ELSE(TARGET forge)
 
     SET_PROPERTY(GLOBAL PROPERTY USE_FOLDERS ON)
-    FIND_PACKAGE(FreeImage REQUIRED)
+    FIND_PACKAGE(Forge REQUIRED)
     FIND_PACKAGE(OpenGL REQUIRED)
-    FIND_PACKAGE(Forge REQUIRED)
 
     SET(X11_LIBS "")
 
-    INCLUDE_DIRECTORIES(
-        ${FORGE_INCLUDE_DIRS}
-        ${FREEIMAGE_INCLUDE_PATH}
-        )
+    INCLUDE_DIRECTORIES(${FORGE_INCLUDE_DIRS})
 
     # OS Definitions
     IF(UNIX)
@@ -96,11 +92,9 @@
     GET_FILENAME_COMPONENT(DIR_NAME ${FULL_DIR_NAME} NAME)
 
     IF(TARGET forge)
-        BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} forge
-            "${FREEIMAGE_LIBRARY};${OPENGL_gl_LIBRARY}")
+        BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} forge "")
     ELSE(TARGET forge)
-        BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} ${FORGE_LIBRARIES}
-            "${FREEIMAGE_LIBRARY};${OPENGL_gl_LIBRARY};${X11_LIBS};")
+        BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} ${FORGE_LIBRARIES} "${X11_LIBS};${OPENGL_gl_LIBRARY}")
     ENDIF()
 ENDFOREACH()
 
@@ -132,11 +126,10 @@
             GET_FILENAME_COMPONENT(DIR_NAME ${FULL_DIR_NAME} NAME)
 
             IF(TARGET forge)
-                BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} forge
-                    "${FREEIMAGE_LIBRARY};${CUDA_LIBRARIES}")
+                BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} forge "${CUDA_LIBRARIES}")
             ELSE(TARGET forge)
                 BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} ${FORGE_LIBRARIES}
-                    "${FREEIMAGE_LIBRARY};${OPENGL_gl_LIBRARY};${X11_LIBS};${CUDA_LIBRARIES}")
+                    "${X11_LIBS};${OPENGL_gl_LIBRARY};${CUDA_LIBRARIES}")
             ENDIF()
         ENDFOREACH()
     ELSE()
@@ -160,11 +153,10 @@
             GET_FILENAME_COMPONENT(DIR_NAME ${FULL_DIR_NAME} NAME)
 
             IF(TARGET forge)
-                BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} forge
-                    "${FREEIMAGE_LIBRARY};${OPENGL_gl_LIBRARY};${OpenCL_LIBRARIES}")
+                BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} forge "${OpenCL_LIBRARIES};${OPENGL_gl_LIBRARY}")
             ELSE(TARGET forge)
                 BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} ${FORGE_LIBRARIES}
-                    "${FREEIMAGE_LIBRARY};${OPENGL_gl_LIBRARY};${X11_LIBS};${OpenCL_LIBRARIES}")
+                    "${X11_LIBS};${OPENGL_gl_LIBRARY};${OpenCL_LIBRARIES}")
             ENDIF()
         ENDFOREACH()
     ELSE()

=== src/backend/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.0)

####################### BEGIN - Backend agnostic upstream dependencies #####################

if(USE_HUNTER)
    hunter_add_package(Boost COMPONENTS system filesystem)
    find_package(Boost REQUIRED COMPONENTS system filesystem)

    hunter_add_package(glm)
    find_package(glm CONFIG REQUIRED)

    hunter_add_package(freetype)
    find_package(freetype REQUIRED)
else()
    FIND_PACKAGE(Boost REQUIRED)

    OPTION(USE_SYSTEM_GLM "Use the system GLM library" OFF)
    IF(USE_SYSTEM_GLM)
      FIND_PACKAGE(glm REQUIRED)
    ELSE()
      INCLUDE(build_glm)
    ENDIF()

    OPTION(USE_SYSTEM_FREETYPE "Use the system Freetype library" OFF)
    IF(USE_SYSTEM_FREETYPE)
      FIND_PACKAGE(Freetype REQUIRED)
    ELSE()
      INCLUDE(build_freetype)
    ENDIF()
endif()

INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${GLM_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${FREETYPE_INCLUDE_DIRS})

IF(UNIX)
    FIND_PACKAGE(FontConfig REQUIRED)
    INCLUDE_DIRECTORIES("${FONTCONFIG_INCLUDE_DIR}")
ENDIF(UNIX)

if(USE_FREEIMAGE)
	FIND_PACKAGE(FreeImage REQUIRED)

	INCLUDE_DIRECTORIES(${FREEIMAGE_INCLUDE_PATH})
	ADD_DEFINITIONS(-DUSE_FREEIMAGE)
endif()

SET(USE_WINDOW_TOOLKIT "glfw3" CACHE STRING "Choose Window toolkit")
SET_PROPERTY(CACHE USE_WINDOW_TOOLKIT PROPERTY STRINGS "glfw3" "sdl2")

IF(${USE_WINDOW_TOOLKIT} STREQUAL "glfw3")
    #FIXME LATER: glfw3Config.cmake file provided by glfw 3.*
    # is found on different locations in different linux/unix
    # distributions, thus causing glfw3 not found errors.
    # DON'T REPLACE GLFW with glfw3 in find_package command.
    FIND_PACKAGE(GLFW REQUIRED)
    IF(GLFW_FOUND)
        SET(WTK_INCLUDE_DIRS ${GLFW_INCLUDE_DIR})
        SET(WTK_LIBRARIES ${GLFW_LIBRARY})
        ADD_DEFINITIONS(-DUSE_GLFW)
    ELSE(GLFW_FOUND)
        MESSAGE(FATAL_ERROR "GLFW not found")
    ENDIF(GLFW_FOUND)
ENDIF()

IF(${USE_WINDOW_TOOLKIT} STREQUAL "sdl2")
    FIND_PACKAGE(SDL2 REQUIRED)
    IF(SDL2_FOUND)
        SET(WTK_INCLUDE_DIRS ${SDL2_INCLUDE_DIR})
        SET(WTK_LIBRARIES ${SDL2_LIBRARY})
        ADD_DEFINITIONS(-DUSE_SDL)
    ELSE(SDL2_FOUND)
        MESSAGE(FATAL_ERROR "SDL2 not found")
    ENDIF(SDL2_FOUND)
ENDIF()

####################### END - Backend agnostic upstream dependencies #######################

ADD_EXECUTABLE(glsl2cpp "${PROJECT_SOURCE_DIR}/CMakeModules/glsl2cpp.cpp")

INCLUDE(GLSLtoH)

SET(glsl_shader_headers "shader_headers")

FILE(GLOB glsl_shaders "glsl_shaders/*.glsl")

LIST(SORT glsl_shaders)

SOURCE_GROUP("src\\backend\\glsl_shaders" FILES ${glsl_shaders})

GLSL_TO_H(
    SOURCES ${glsl_shaders}
    VARNAME  shader_files
    EXTENSION "hpp"
    OUTPUT_DIR ${glsl_shader_headers}
    TARGETS glsl_shader_targets
    NAMESPACE "glsl"
    EOD "0"
    )

# DON'T REMOVE CURRENT BINARY DIRECTORY FROM
# INCLUDE_DIRECTORIES, IT IS USED TO FIND
# AUTO-GENERATED GLSL HEADERS
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

ADD_SUBDIRECTORY(opengl)

=== src/backend/opengl/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,8 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 3.0)
-# Prior to GLM 0.9.7.0, the package is found by the FindGLM.cmake module.
-# This was removed with GLM 0.9.7.0, instead a glm-config.cmake configuration
-# file is provided. Therefore, both FIND_PACKAGE calls are necessary.
-FIND_PACKAGE(GLM QUIET)
-FIND_PACKAGE(glm QUIET)
+
+FIND_PACKAGE(OpenGL REQUIRED)
+
+INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})
 
 OPTION(USE_SYSTEM_GLBINDING "Use system glbinding" OFF)
 IF(USE_SYSTEM_GLBINDING)
@@ -15,82 +14,18 @@
     INCLUDE(build_glbinding)
 ENDIF(USE_SYSTEM_GLBINDING)
 
-INCLUDE(GLSLtoH)
-
-IF((NOT glm_FOUND AND NOT GLM_FOUND) OR (${USE_LOCAL_GLM}))
-  SET(USE_LOCAL_GLM ON)
-  MESSAGE(STATUS "Downloading GLM headers.")
-  INCLUDE(build_glm)
-ELSE()
-  MESSAGE(STATUS "Using System GLM")
-ENDIF()
-
-FIND_PACKAGE(Freetype QUIET)
-
-IF(NOT FREETYPE_FOUND OR ${USE_LOCAL_FREETYPE})
-  SET(USE_LOCAL_FREETYPE ON)
-  MESSAGE(STATUS "Downloading and building Freetype libraries.")
-  INCLUDE(build_freetype)
-ELSE()
-  MESSAGE(STATUS "Using System FreeType2")
-ENDIF()
-
-IF(UNIX)
-    FIND_PACKAGE(FontConfig REQUIRED)
-ENDIF(UNIX)
-
-IF(${USE_WINDOW_TOOLKIT} STREQUAL "glfw3")
-    FIND_PACKAGE(GLFW REQUIRED)
-    IF(GLFW_FOUND)
-        SET(WTK_INCLUDE_DIRS ${GLFW_INCLUDE_DIR})
-        SET(WTK_LIBRARIES ${GLFW_LIBRARY})
-        ADD_DEFINITIONS(-DUSE_GLFW)
-    ELSE(GLFW_FOUND)
-        MESSAGE(FATAL_ERROR "GLFW not found")
-    ENDIF(GLFW_FOUND)
-ENDIF()
-
-IF(${USE_WINDOW_TOOLKIT} STREQUAL "sdl2")
-    FIND_PACKAGE(SDL2 REQUIRED)
-    IF(SDL2_FOUND)
-        SET(WTK_INCLUDE_DIRS ${SDL2_INCLUDE_DIR})
-        SET(WTK_LIBRARIES ${SDL2_LIBRARY})
-        ADD_DEFINITIONS(-DUSE_SDL)
-    ELSE(SDL2_FOUND)
-        MESSAGE(FATAL_ERROR "SDL2 not found")
-    ENDIF(SDL2_FOUND)
-ENDIF()
-
-
 IF(WIN32)
     ADD_DEFINITIONS(-DFGDLL)
 ENDIF(WIN32)
 
-# OS Definitions
-IF(UNIX)
-    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
-ELSE(UNIX) #Windows
-    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
-ENDIF(UNIX)
-
-# DON'T REMOVE CURRENT BINARY DIRECTORY FROM
-# INCLUDE_DIRECTORIES, IT IS USED TO FIND
-# AUTO-GENERATED GLSL HEADERS
 INCLUDE_DIRECTORIES(
     ${CMAKE_INCLUDE_PATH}
-    ${FREETYPE_INCLUDE_DIRS}
-    ${GLM_INCLUDE_DIRS}
     ${WTK_INCLUDE_DIRS}
     ${CMAKE_CURRENT_SOURCE_DIR}
-    ${CMAKE_CURRENT_BINARY_DIR}
     "${PROJECT_SOURCE_DIR}/src/api/c"
     "${PROJECT_SOURCE_DIR}/src/api/cpp"
     "${PROJECT_SOURCE_DIR}/src/backend"
     )
-
-IF(UNIX)
-    INCLUDE_DIRECTORIES("${FONTCONFIG_INCLUDE_DIR}")
-ENDIF(UNIX)
 
 FILE(GLOB api_headers
     "${PROJECT_SOURCE_DIR}/include/*.h"
@@ -128,11 +63,6 @@
     "*.cpp"
     )
 
-SET(glsl_shader_headers
-    "shader_headers")
-FILE(GLOB glsl_shaders
-    "shaders/*.glsl")
-
 LIST(SORT c_api_headers)
 LIST(SORT c_api_sources)
 LIST(SORT cpp_api_headers)
@@ -141,7 +71,6 @@
 LIST(SORT bknd_sources)
 LIST(SORT gl_headers)
 LIST(SORT gl_sources)
-LIST(SORT glsl_shaders)
 
 SOURCE_GROUP(inc FILES ${api_headers})
 
@@ -173,18 +102,6 @@
     SOURCE_GROUP("src\\backend\\opengl\\sdl\\sources" FILES ${wtk_sources})
 ENDIF()
 
-SOURCE_GROUP("src\\backend\\opengl\\glsl" FILES ${glsl_shaders})
-
-GLSL_TO_H(
-    SOURCES ${glsl_shaders}
-    VARNAME  shader_files
-    EXTENSION "hpp"
-    OUTPUT_DIR ${glsl_shader_headers}
-    TARGETS glsl_shader_targets
-    NAMESPACE "glsl"
-    EOD "0"
-    )
-
 ADD_LIBRARY(forge SHARED
     ${api_headers}
     ${c_api_headers}
@@ -209,6 +126,11 @@
     )
 
 ADD_DEPENDENCIES(forge ${glsl_shader_targets})
+
+IF (NOT USE_SYSTEM_FREETYPE AND NOT USE_HUNTER)
+    ADD_DEPENDENCIES(forge freetype)
+ENDIF()
+
 IF(USE_SYSTEM_GLBINDING)
     TARGET_LINK_LIBRARIES(forge PRIVATE glbinding::glbinding)
 ELSE(USE_SYSTEM_GLBINDING)
@@ -218,8 +140,8 @@
 ENDIF(USE_SYSTEM_GLBINDING)
 
 SET_TARGET_PROPERTIES(forge PROPERTIES
-                      VERSION ${FG_VERSION}
-                      SOVERSION 0)
+                      VERSION "${FG_VERSION}"
+                      SOVERSION "${FG_VERSION_MAJOR}")
 
 INSTALL(TARGETS forge
         EXPORT FORGE

=== debian/changelog ===
forge (1.0.1-4) unstable; urgency=medium

  * Team upload.
  * [7dfab77] chore: Add salsa-ci.yml for CI integration
  * [f53ee97] fix: Fix FTBFS by addressing OpenGL errors. (Closes: #1090222)
  * [9cf0061] chore: Update patches series file

 -- Anton Gladky <gladk@debian.org>  Sat, 05 Jul 2025 19:45:38 +0200

forge (1.0.1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061943

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 09:07:21 +0000

forge (1.0.1-3) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Team upload

  [ Timo Aaltonen ]
  * tests: Add allow-stderr to restrictions

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 09 Aug 2018 15:29:02 +0200

forge (1.0.1-2) unstable; urgency=medium

  * Upload to unstable
  * Team upload
  * Add -Wno-dev to tests, to avoid cmake warnings being sent to stderr
  * cherry-pick two upstream fixes for build failures (Closes: #888931):
    - debian/patches/63e4a2037e42c00554a26de2355d962f91a9ab20.patch:
    - debian/patches/befa265294fd9ff679dece7874c1de50fea97b25.patch:

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 04 Jul 2018 11:58:54 +0200

forge (1.0.1-1) experimental; urgency=medium

  * Switch from git-dpm to gbp
  * New upstream version 1.0.1
  * Rebase the patch queue
    - Drop 0003-Consistent-definition-of-USE_SYSTEM-flags-for-glbind.patch,
      applied upstream
    - Refresh 0004-Fix-spelling-errors.patch
  * Build depends on Boost
  * Bump soversion to 1
  * Update copyright information

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 20 May 2017 14:16:39 +0100

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,10 @@
 Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
 Section: libs
 Priority: optional
-Build-Depends: cmake (>= 3.0),
+Build-Depends: dpkg-dev (>= 1.22.5), cmake (>= 3.0),
                debhelper (>= 10),
                dpkg-dev (>= 1.17.14),
+               libboost-dev,
                libfontconfig1-dev,
                libfreeimage-dev,
                libfreetype6-dev,
@@ -19,7 +20,10 @@
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/forge.git
 Homepage: https://github.com/arrayfire/forge
 
-Package: libforge0
+Package: libforge1t64
+Provides: ${t64:Provides}
+Replaces: libforge1
+Breaks: libforge1 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends},
@@ -37,7 +41,7 @@
 Multi-Arch: same
 Section: libdevel
 Depends: ${misc:Depends},
-         libforge0 (= ${binary:Version})
+         libforge1t64 (= ${binary:Version})
 Suggests: forge-doc <!nodoc>
 Description: development files for forge
  A prototype of the OpenGL interop library that can be used with ArrayFire. The

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

BUILD_OPTIONS = -DBUILD_EXAMPLES=OFF \
		-DFG_INSTALL_CMAKE_DIR="lib/$(DEB_HOST_MULTIARCH)/cmake/Forge" \
		-DFG_INSTALL_LIB_DIR="lib/$(DEB_HOST_MULTIARCH)" \
		-DUSE_SYSTEM_FREETYPE=ON \
		-DUSE_SYSTEM_GLBINDING=ON \
		-DUSE_SYSTEM_GLM=ON

%:
	dh $@

override_dh_auto_configure-arch:
	dh_auto_configure -- $(BUILD_OPTIONS) \
		-DBUILD_DOCUMENTATION=OFF

override_dh_auto_configure-indep:
ifeq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
	dh_auto_configure -- $(BUILD_OPTIONS) \
		-DBUILD_DOCUMENTATION=ON \
		-DFG_INSTALL_DOC_DIR="share/doc/forge-doc"
endif

=== debian/tests/control ===
Test-Command: cp -a CMakeModules examples/* $AUTOPKGTEST_TMP
 ; cd $AUTOPKGTEST_TMP
 ; mkdir build
 ; cd build
 ; cmake -DBUILD_EXAMPLES_CUDA=OFF -DBUILD_EXAMPLES_OPENCL=ON -DUSE_SYSTEM_CL2HPP=ON -Wno-dev ..
 ; cmake --build .
Depends: @, cmake, g++ | c++-compiler, libfreeimage-dev, libgl1-mesa-dev | libgl-dev,
 ocl-icd-opencl-dev | opencl-dev, opencl-clhpp-headers
Restrictions: allow-stderr

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/forge-$1\.tar\.gz/ \
https://github.com/arrayfire/forge/tags .*/v?(\d\S*)\.tar\.gz
